<template>
  <div
    class="fr-upload-group"
    :class="{ 'fr-input-group--error': error }"
  >
    <label
      class="fr-label"
      :for="name"
    >
      {{ displayLabel }}
      <span
        v-if="hint"
        class="fr-hint-text"
      >
        {{ hint }}
      </span>
    </label>
    <input
      :id="name"
      class="fr-upload"
      :class="{ 'fr-input--error': error }"
      :aria-describedby="ariaDescribedby"
      type="file"
      :name="name"
      :required="required"
      :accept="accept"
      @input="onValidate"
      @invalid="onValidate"
    />
    <div
      v-if="error"
      :id="errorId"
      class="fr-messages-group"
      aria-live="assertive"
    >
      <p class="fr-message fr-message--error">
        {{ error }}
      </p>
    </div>
  </div>
</template>

<script setup>
  const props = defineProps({
    label: {
      type: String,
      required: true
    },
    name: {
      type: String,
      required: true
    },
    accept: {
      type: String,
      required: true
    },
    required: {
      type: Boolean,
      default: false
    },
    hint: {
      type: String,
      default: undefined
    }
  })

  const error = ref('')

  const errorId = computed(() => `${props.name}-error-desc-error`)

  const ariaDescribedby = computed(() => (error ? errorId : undefined))

  const displayLabel = computed(() =>
    props.required ? `${props.label} *` : props.label
  )

  function onValidate(event) {
    const input = event.target
    error.value = input.validationMessage
  }
</script>
